// pages/login/login.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    loginName: null,
    password: null,
    checkPass: false,
    errorMsg: ''
  },
  inputAccount(e) {
    this.setData({
      loginName: e.detail.value
    });
    //console.log(e);
    if (this.data.loginName && this.data.password) {
      this.setData({
        checkPass: true
      });
    } else {
      this.setData({
        checkPass: false
      });
    }

  },
  inputPassword(e) {
    this.setData({
      password: e.detail.value
    });
    //console.log(e);
    if (this.data.loginName && this.data.password) {
      this.setData({
        checkPass: true
      });
    } else {
      this.setData({
        checkPass: false
      });
    }
  },
  loginUser(e) {
    let that = this;
    let { loginName, password } = this.data;
    wx.request({
      url: getApp().globalData.postHeadAgreement +'://cdgl.xinyhy.cn/restapi/wechat/login',
      data: {
        loginName,
        password
      },
      method: 'POST',
      success(res) {
        //console.log(res1);
        //console.log(res1.data.code == 1);
        if (res.data.code == 1) {
          that.setData({
            errorMsg: res.data.msg
          })
        } else {
          //返回该用户
          //跳转到上一页
          wx.setStorageSync("userInfo", res.data);
          wx.setStorageSync("isLogin", true);
          //let url = `/pages/ucenter/index/index`;
          wx.navigateBack();
          //wx.redirectTo({
          // url
          //});
        }
      }
    });
  },
  goToRegister(e) {
    console.log(e);
    let url = '/pages/register/register';
    wx.redirectTo({
      url
    })
  },
  goToForget(e){
    console.log(e);
    let url = '/pages/forget/forget';
    wx.redirectTo({
      url
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})