// pages/chargemoney/chargemoney.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    chargemoney_select: null,
    userInfo: {},
    isLogin: false
  },
  bindMoneyTap(e) {
    let chargemoney_select = e.currentTarget.id;
    this.setData({
      chargemoney_select
    });
  },
  saveMoney(e) {
    //console.log(e);
    let chargemoney_select = e.detail.value;
    this.setData({
      chargemoney_select
    });
  },
  beginChargemoney(e) {
    //console.log(this.data.chargemoney_select);
    let that = this;
    if (this.data.chargemoney_select) {
      wx.showLoading({
        title: '充值中...',
        mask: true
      });
      wx.login({
        success(res) {
          console.log(res);
          if (res.code) {
            // 发起网络请求
            wx.request({
              url: getApp().globalData.postHeadAgreement +'://cdgl.xinyhy.cn/restapi/wechatpay/dopaychargmoney',
              data: {
                //outTradeNo: new Date().getTime(), //订单号
                totalFee: that.data.chargemoney_select, //钱
                //totalFee:0.01,
                code: res.code
              },
              header: {
                'content-type': 'application/x-www-form-urlencoded;charset=utf-8',
              },
              method: 'POST',
              success(res1) {
                //console.log(res1);
                wx.requestPayment({
                  timeStamp: res1.data.timeStamp,
                  nonceStr: res1.data.nonceStr,
                  package: res1.data.package,
                  signType: res1.data.signType,
                  paySign: res1.data.paySign,
                  success(res2) {
                    console.log(res2);
                    wx.request({
                      url: getApp().globalData.postHeadAgreement +'://cdgl.xinyhy.cn/restapi/pileLog/wechatrechargeback',
                      data: {
                        userId: that.data.userInfo.userId,
                        rechargeMoney: that.data.chargemoney_select
                        //rechargeMoney: 0.01,
                      },
                      method: 'POST',
                      success(res3) {
                        wx.hideLoading();
                        let {
                          data
                        } = res3;
                        if (data && data.code == 200) {
                          wx.showModal({
                            showCancel: false,
                            content: '充值成功'
                          });
                        } else {
                          wx.showModal({
                            showCancel: false,
                            content: '充值失败'
                          });
                        }
                      }
                    });
                  },
                  fail(res3) {
                    wx.hideLoading();
                    console.log(res3);
                  }
                });
              }
            });
          } else {
            wx.hideLoading();
            console.log('登录失败！' + res.errMsg)
          }
        }
      })


    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    let userInfo = wx.getStorageSync('userInfo');
    let isLogin = wx.getStorageSync('isLogin');

    // 页面显示
    if (userInfo && isLogin) {
      //console.log(userInfo);
      //userInfo.flag = true;
      this.setData({
        userInfo: userInfo,
        isLogin: isLogin
      });
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function() {

  }
})